Attribute VB_Name = "Modul_RngToCSV"
Option Explicit
                                ' Modul_RngToCSV
Sub RangetoCSV_Export()         ' Speichert markierte Zellbereiche in eine Semikolongetrennte *.CSV-Datei
                                ' Prft ob Startzelle des Bereiches "Standort" ist
    Dim Rng As Range
    Dim WorkRng As Range            ' fr markierten Zellbereich aus Kopfzeilen + Datenzellen
    Dim xFile As Variant            ' Prft:
    Dim zelle As Variant            ' 1. Zelle = ErsteZelleValue (hier Standart)
    Dim ZelleAnfang As Variant      ' 2. Ist ErsteZellValue nicht die einzige Zelle?
    Dim ZelleEnde   As Variant      ' 3. Fehlt noch:
    Dim CSVName As String           '    Ist die letzte Spalte eine Kopfzelle
    Dim lngDauer As Long            '    Ist die letzte zeile eine Datenzelle (Inhalt vorhanden)
    'Dim Anzahl As Long
    Dim VAdrRow As Long
    Dim VAdrCol As Long
    Dim ErsteZelleValue As String
    Dim ErrorFlag As Boolean
    
    ErsteZelleValue = "Standort"    ' Inhalt der ersten Zelle der Kopfzeile
    CSVName = "CSV-Transfer"        ' Dateineme fr CSV-Datei
    lngDauer = 1
    On Error Resume Next
    Set WorkRng = Application.Selection
    Range(WorkRng).Select ' Dauer der Anzeige CSVNAme gespeichert
    
    Call range_report(ErsteZelleValue, ErrorFlag)
    If ErrorFlag = True Then GoTo Fehler
    
    '*** Bearbeiten
    Application.ActiveSheet.Copy        'Kopiert in neues Workbook unter "Mappe_n)
    Application.ActiveSheet.Cells.Clear 'lscht alle Zellen in neuer Mappe_n
    WorkRng.Copy Application.ActiveSheet.Range("A1") 'Kopiert "Bereich/Range" ab A1 in Mappe_n
    Application.DisplayAlerts = False   'WarnMeldung wenn berschreiben ? AUS
    Application.ActiveWorkbook.SaveAs Filename:=ThisWorkbook.Path & "\" & CSVName, FileFormat:=xlCSV, _
        CreateBackup:=False, Local:=True    'Speichert im Pfad der Exceldatei
    Application.DisplayAlerts = True    'WarnMeldung berschreiben ? Ein
    Application.ActiveWorkbook.Close True
    Call MessageBox_zeitgesteuert(CSVName, lngDauer)
Fehler:
End Sub

Sub range_report(ErsteZelleValue, ErrorFlag) 'Datensatz auf Gltigkeit prfen
    
    Dim numRow As Variant
    Dim cntrow As Variant
    Dim numCol As Variant
    Dim cntcol As Variant
    'Dim ErsteZelleValue As String
    Dim r As Range
    Dim s As String
    Dim Startzelle As Range
    Dim nLastRow As Long, nLastColumn As Long
    Dim nFirstRow As Long, nFirstColumn As Long
    Dim Zellinhalt As Variant
    Dim Anzahl As Variant
    
    ErrorFlag = False          'Fehlerflag rcksetzten
    Set r = Selection          'ausgewhlter Bereich als Range r speichern
    s = r(1).Address
    
    '** Prfen: Inhalt der Startzelle und Anzahl der markierten Zeile und Spalten. je >=2
    
    numRow = r.Rows.Count       'Anzahl Zeilen
    cntrow = numRow
    numCol = r.Columns.Count
    cntcol = numCol
    
    Anzahl = Selection.Count        'Anzahl der markierte Zellen
    If ActiveCell.Value <> ErsteZelleValue Then 'Prfen ob Wert der 1. Zelle der Kopfzeile stimmt
      MsgBox "!! Die erste Zelle muss  """ & ErsteZelleValue & """  sein !!", vbCritical
      ErrorFlag = True
      GoTo Brexit
    ElseIf numRow < 2 Then         'Prfen ob mehr als eine Zeile ausgewhlt ist
      MsgBox "!! Bitte einen Bereich auswhlen !!", vbCritical
      ErrorFlag = True
      GoTo Brexit
    ElseIf numCol < 2 Then        'Prfen ob mehr als eine Spalte ausgewhlt ist
      MsgBox "!! Bitte einen Bereich auswhlen !!", vbCritical
      ErrorFlag = True
      GoTo Brexit
    End If
    
   Do While cntcol > 0                     'Prfen ob die Kopfzeile ohne Leerzeichen ist
      If ActiveCell.Value = "" Then
        GoTo FehlerZeile
      Else
         cntcol = cntcol - 1
         If ActiveCell.Value = "" Then GoTo FehlerZeile
         ActiveCell.Offset(0, 1).Select             'Spalte + 1
      End If
      'MsgBox (numCol)
   Loop
   ActiveCell.Offset(0, -numCol).Select     'Zelle wieder auf Startzelle (hier Standort)
   cntrow = cntrow - 1
   ActiveCell.Offset(1, 0).Select           'Zeile +1  Standort nicht nochmal prfen
    Do While cntrow > 0                     'Prfen ob die 1. Spalte ohne Leerzeichen ist
      If ActiveCell.Value = "" Then
        GoTo FehlerSpalte
      Else
         cntrow = cntrow - 1
         If ActiveCell.Value = "" Or ActiveCell.Value = ErsteZelleValue Then GoTo FehlerSpalte
         ActiveCell.Offset(1, 0).Select             'Zeile +1
      End If
      'MsgBox (numCol)
   Loop
   GoTo Brexit                 'Zellauswahl gltig
FehlerZeile:
    MsgBox ("Zellauswahl ungltig, da Leerzelle in Kopfzeile"), vbCritical
    ErrorFlag = True
    GoTo Brexit
FehlerSpalte:
    MsgBox ("Zellauswahl ungltig, da Leerzelle in 1.Spalte oder eine weitere Kopfzelle") & _
                                                    ("in der 1. Spalte"), vbCritical
    ErrorFlag = True
Brexit:
 'MsgBox (ErrorFlag)
End Sub

Sub MessageBox_zeitgesteuert(CSVName, lngDauer) 'Beendet die Windows "MessageBox" nach lngDauer
Dim iAnzeige As Integer
Dim objShell As Object
Set objShell = CreateObject("WScript.Shell")
iAnzeige = objShell.Popup("Die neue Datei  " & CSVName & ".CSV  wurde gespeichert", _
  lngDauer, "CSV fr BOOKcook Import                                    Anzeigedauer: " & lngDauer _
  & " sec.", vbInformation)
End Sub
